searchNodes=[{"doc":"A module for interactions with message store","ref":"MessageStore.html","title":"MessageStore","type":"module"},{"doc":"","ref":"MessageStore.html#category/1","title":"MessageStore.category/1","type":"function"},{"doc":"","ref":"MessageStore.html#expected_version/2","title":"MessageStore.expected_version/2","type":"function"},{"doc":"","ref":"MessageStore.html#fetch/4","title":"MessageStore.fetch/4","type":"function"},{"doc":"","ref":"MessageStore.html#is_conn/1","title":"MessageStore.is_conn/1","type":"macro"},{"doc":"","ref":"MessageStore.html#project/2","title":"MessageStore.project/2","type":"function"},{"doc":"","ref":"MessageStore.html#stream_name_to_id/1","title":"MessageStore.stream_name_to_id/1","type":"function"},{"doc":"","ref":"MessageStore.html#to_result/2","title":"MessageStore.to_result/2","type":"function"},{"doc":"A data fixtures.","ref":"MessageStore.Fixtures.html","title":"MessageStore.Fixtures","type":"module"},{"doc":"","ref":"MessageStore.Fixtures.html#message/1","title":"MessageStore.Fixtures.message/1","type":"function"},{"doc":"","ref":"MessageStore.Fixtures.html#recorded_event/1","title":"MessageStore.Fixtures.recorded_event/1","type":"function"},{"doc":"A serializer that uses the JSON format.","ref":"MessageStore.JsonSerializer.html","title":"MessageStore.JsonSerializer","type":"module"},{"doc":"Deserialize given JSON binary data to the expected type.","ref":"MessageStore.JsonSerializer.html#deserialize/2","title":"MessageStore.JsonSerializer.deserialize/2","type":"function"},{"doc":"Serialize given term to JSON binary data.","ref":"MessageStore.JsonSerializer.html#serialize/1","title":"MessageStore.JsonSerializer.serialize/1","type":"function"},{"doc":"An extra functions for Map data type.","ref":"MessageStore.MapExtra.html","title":"MessageStore.MapExtra","type":"module"},{"doc":"Fetches the value for a specific path in the given map, erroring out if map doesn't contain path . If map contains path , the corresponding value is returned. If map doesn't contain path , a PathError exception is raised. Examples iex&gt; a = %{ a : 1 , b : %{ c : 2 } } iex&gt; MapExtra . fetch_in! ( a , [ :a ] ) 1","ref":"MessageStore.MapExtra.html#fetch_in!/2","title":"MessageStore.MapExtra.fetch_in!/2","type":"function"},{"doc":"Fetches the value for a specific path in the given map . If map contains the given path then its value is returned in the shape of {:ok, value} . If map doesn't contain path , :error is returned. Examples iex&gt; a = %{ a : 1 , b : %{ c : 2 } } iex&gt; MapExtra . fetch_in ( a , [ :a ] ) { :ok , 1 } iex&gt; a = %{ a : 1 , b : %{ c : 2 } } iex&gt; MapExtra . fetch_in ( a , [ :b , :c ] ) { :ok , 2 } iex&gt; a = %{ a : 1 , b : %{ c : 2 } } iex&gt; MapExtra . fetch_in ( a , [ :b , :d ] ) :error","ref":"MessageStore.MapExtra.html#fetch_in/2","title":"MessageStore.MapExtra.fetch_in/2","type":"function"},{"doc":"A module for build, copy and folow message data.","ref":"MessageStore.Message.html","title":"MessageStore.Message","type":"module"},{"doc":"Create event data struct from message map. Examples iex&gt; message = %{ type : &quot;Foo&quot; , data : %{ foo : 1 } , metadata : %{ bar : 2 } } iex&gt; Message . build ( message ) % EventStore.EventData { event_id : nil , event_type : &quot;Foo&quot; , data : %{ foo : 1 } , metadata : %{ bar : 2 } , causation_id : nil , correlation_id : nil }","ref":"MessageStore.Message.html#build/1","title":"MessageStore.Message.build/1","type":"function"},{"doc":"The copy function constructs a message from another message's data. Examples iex&gt; recorded_message = % EventStore.RecordedEvent { ...&gt; causation_id : nil , ...&gt; correlation_id : &quot;abcd1234&quot; , ...&gt; created_at : ~U[2021-07-15 12:15:07.379908Z] , ...&gt; data : %{ foo : &quot;bazinga&quot; } , ...&gt; event_id : &quot;b9fcdccd-a495-4df3-889a-4b38f35a2618&quot; , ...&gt; event_number : 935 , ...&gt; event_type : &quot;Test&quot; , ...&gt; metadata : %{ bar : &quot;baz&quot; , moo : 1 } , ...&gt; stream_uuid : &quot;test-123&quot; , ...&gt; stream_version : 935 ...&gt; } iex&gt; Message . copy ( &quot;Foo&quot; , recorded_message , [ :data , [ :metadata , :bar ] ] ) % EventStore.EventData { event_id : nil , event_type : &quot;Foo&quot; , data : %{ foo : &quot;bazinga&quot; } , metadata : %{ bar : &quot;baz&quot; } , causation_id : nil , correlation_id : nil } Warning Copying the metadata should be used with extreme caution, and has no practical use in everyday applicative logic. Except for certain testing and infrastructural scenarios, copying the identifying metadata from one message to another can result in significant malfunctions if the copied message is then written to a stream and processed.","ref":"MessageStore.Message.html#copy/3","title":"MessageStore.Message.copy/3","type":"function"},{"doc":"Constructing a message from a preceding message. Following a message has almost identical behavior to a message copy/3 method. The follow message leverages the implementation of copy/3 to fulfill its purpose. Message Workflows Messages frequently represent subsequent steps or stages in a process. Subsequent messages follow after preceding messages. Selected data or metadata from the preceding message is copied to the subsequent messages. Examples iex&gt; recorded_message = % EventStore.RecordedEvent { ...&gt; causation_id : nil , ...&gt; correlation_id : &quot;abcd1234&quot; , ...&gt; created_at : ~U[2021-07-15 12:15:07.379908Z] , ...&gt; data : %{ foo : &quot;bazinga&quot; } , ...&gt; event_id : &quot;b9fcdccd-a495-4df3-889a-4b38f35a2618&quot; , ...&gt; event_number : 935 , ...&gt; event_type : &quot;Test&quot; , ...&gt; metadata : %{ bar : &quot;baz&quot; , moo : 1 } , ...&gt; stream_uuid : &quot;test-123&quot; , ...&gt; stream_version : 935 ...&gt; } iex&gt; Message . follow ( &quot;Foo&quot; , recorded_message , [ :data , [ :metadata , :bar ] ] ) % EventStore.EventData { event_id : nil , event_type : &quot;Foo&quot; , data : %{ foo : &quot;bazinga&quot; } , metadata : %{ bar : &quot;baz&quot; } , causation_id : &quot;b9fcdccd-a495-4df3-889a-4b38f35a2618&quot; , correlation_id : &quot;abcd1234&quot; }","ref":"MessageStore.Message.html#follow/3","title":"MessageStore.Message.follow/3","type":"function"},{"doc":"","ref":"MessageStore.Message.html#is_data_or_metadata/1","title":"MessageStore.Message.is_data_or_metadata/1","type":"macro"},{"doc":"","ref":"MessageStore.Message.html#is_message_type/1","title":"MessageStore.Message.is_message_type/1","type":"macro"},{"doc":"","ref":"MessageStore.Message.html#is_module_name/1","title":"MessageStore.Message.is_module_name/1","type":"macro"},{"doc":"","ref":"MessageStore.Message.html#is_version/1","title":"MessageStore.Message.is_version/1","type":"macro"},{"doc":"","ref":"MessageStore.Message.html#type_from_module/1","title":"MessageStore.Message.type_from_module/1","type":"function"},{"doc":"","ref":"MessageStore.Message.html#write/4","title":"MessageStore.Message.write/4","type":"function"},{"doc":"","ref":"MessageStore.Message.html#t:event_message/0","title":"MessageStore.Message.event_message/0","type":"type"},{"doc":"","ref":"MessageStore.Message.html#t:key/0","title":"MessageStore.Message.key/0","type":"type"},{"doc":"","ref":"MessageStore.Message.html#t:message/0","title":"MessageStore.Message.message/0","type":"type"},{"doc":"","ref":"MessageStore.Message.html#t:message_type/0","title":"MessageStore.Message.message_type/0","type":"type"},{"doc":"","ref":"MessageStore.Message.html#t:path/0","title":"MessageStore.Message.path/0","type":"type"},{"doc":"","ref":"MessageStore.Message.html#t:recorded_message/0","title":"MessageStore.Message.recorded_message/0","type":"type"},{"doc":"","ref":"MessageStore.Message.html#t:stream_name/0","title":"MessageStore.Message.stream_name/0","type":"type"},{"doc":"","ref":"MessageStore.Message.html#t:uuid/0","title":"MessageStore.Message.uuid/0","type":"type"},{"doc":"","ref":"MessageStore.Message.html#t:version/0","title":"MessageStore.Message.version/0","type":"type"},{"doc":"A message handler boilerplate.","ref":"MessageStore.MessageHandler.html","title":"MessageStore.MessageHandler","type":"module"},{"doc":"Subscriber message handler behaviour.","ref":"MessageStore.MessageHandlerBehaviour.html","title":"MessageStore.MessageHandlerBehaviour","type":"behaviour"},{"doc":"A message handler.","ref":"MessageStore.MessageHandlerBehaviour.html#c:handle_message/2","title":"MessageStore.MessageHandlerBehaviour.handle_message/2","type":"callback"},{"doc":"A projection boilerplate and helpers.","ref":"MessageStore.Projection.html","title":"MessageStore.Projection","type":"module"},{"doc":"","ref":"MessageStore.Projection.html#load/4","title":"MessageStore.Projection.load/4","type":"function"},{"doc":"","ref":"MessageStore.Projection.html#t:fetch/0","title":"MessageStore.Projection.fetch/0","type":"type"},{"doc":"Projection behaviour.","ref":"MessageStore.ProjectionBehaviour.html","title":"MessageStore.ProjectionBehaviour","type":"behaviour"},{"doc":"A message handler","ref":"MessageStore.ProjectionBehaviour.html#c:handle_message/2","title":"MessageStore.ProjectionBehaviour.handle_message/2","type":"callback"},{"doc":"The projection initial state.","ref":"MessageStore.ProjectionBehaviour.html#c:init/0","title":"MessageStore.ProjectionBehaviour.init/0","type":"callback"},{"doc":"A stream operations.","ref":"MessageStore.Stream.html","title":"MessageStore.Stream","type":"module"},{"doc":"","ref":"MessageStore.Stream.html#query_read_stream/1","title":"MessageStore.Stream.query_read_stream/1","type":"function"},{"doc":"","ref":"MessageStore.Stream.html#read/3","title":"MessageStore.Stream.read/3","type":"function"},{"doc":"A subscribe server for handling messages. Options message_store: module - it's messages store module for access event data/streams. Required. stream_name: string - it's stream name to subscribe for messages. Required. handlers: module - message handlers. Required. subscriber_name: string - unique name. Required. origin_stream_name: string - when is set, filter messages that has in metadata same value in origin_stream_name key. Optional. address: string - used for filter messages with same value in metadata recipient key. Optional. event_store_name: string the name of the event store if provided to EventStore.start_link/1 . start_from: atom is a pointer to the first event to receive. It must be one of: :origin for all events from the start of the stream (default). :current for any new events appended to the stream after the subscription has been created. any positive integer for a stream version to receive events after. buffer_size: integer limits how many in-flight events will be sent to the subscriber process before acknowledgement of successful processing. This limits the number of messages sent to the subscriber and stops their message queue from getting filled with events. Defaults to one in-flight event. transient: boolean is an optional boolean flag to create a transient subscription. By default this is set to false . If you want to create a transient subscription set this flag to true. Your subscription will not be persisted, so if the subscription is restarted, you will receive the events again starting from start_from . An example usage are short lived event handlers that keep their state in memory but still want to have the guarantee to have received all events. It's possible to create a persistent subscription with some name, stop it and later create a transient subscription with the same name. The transient subscription will now receive all events starting from start_from . If you later stop this transient subscription and start a persistent subscription again with the same name, you will receive the events again as if the transient subscription never existed.","ref":"MessageStore.Subscriber.html","title":"MessageStore.Subscriber","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MessageStore.Subscriber.html#child_spec/1","title":"MessageStore.Subscriber.child_spec/1","type":"function"},{"doc":"This module defines the test case to be used by tests that require setting up a connection and database. Finally, if the test case interacts with the database, it cannot be async. For this reason, every test runs inside a transaction which is reset at the beginning of the test unless the test case is marked as async.","ref":"MessageStoreCase.html","title":"MessageStoreCase","type":"module"},{"doc":"","ref":"MessageStore.MapExtra.PathError.html","title":"MessageStore.MapExtra.PathError","type":"exception"}]